#include-once

;~ *** Place la mmoire du processus en mmoire virtuelle ***
;~ http://msdn.microsoft.com/en-us/library/ms682606(VS.85).aspx
Func _ReduitMemoire($pid_processus)
	; ouvre le processus dsign par son "PID"
	Local $a_handle = DllCall("kernel32.dll", "int", "OpenProcess", "int", 0x1f0fff, "int", False, "int", $pid_processus)
	; libre la mmoire
	Local $a_retour = DllCall("psapi.dll", "int", "EmptyWorkingSet", "long", $a_handle[0])
	; fermeture du "handle"
	DllCall("kernel32.dll", "int", "CloseHandle", "int", $a_retour[0])
	
	Return $a_retour[0]
EndFunc   ;==>_ReduitMemoire

;~ *** Suspend le processus ***
Func _SuspendProcessus($pid_processus)
	Local Const $PROCESSUS_SUSPEND_REPREND = 0x800

	Local $a_handle, $a_retour

	; ouvre le processus dsign par son "PID"
	$a_handle = DllCall("kernel32.dll", "int", "OpenProcess", "int", $PROCESSUS_SUSPEND_REPREND, "int", False, "int", $pid_processus)
	
	; suspend le processus
	$a_retour = DllCall("Ntdll.dll", "int", "NtSuspendProcess", "int", $a_handle[0])
		
	; fermeture du "handle"
	DllCall("kernel32.dll", "int", "CloseHandle", "int", $a_retour)

	Return $a_retour[0]
EndFunc   ;==>SuspendProcessus

;~ *** Reprend le processus ***
Func _ReprendProcessus($pid_processus)
	Local Const $PROCESSUS_SUSPEND_REPREND = 0x800

	Local $a_handle, $a_retour

	; ouvre le processus dsign par son "PID"
	$a_handle = DllCall("kernel32.dll", "int", "OpenProcess", "int", $PROCESSUS_SUSPEND_REPREND, "int", False, "int", $pid_processus)
	
	; reprend le processus
	$a_retour = DllCall("Ntdll.dll", "int", "NtResumeProcess", "int", $a_handle[0])

	; fermeture du "handle"
	DllCall("kernel32.dll", "int", "CloseHandle", "int", $a_retour)

	Return $a_retour[0]
EndFunc   ;==>ReprendProcessus

Func dbg($msg)
	DllCall("kernel32.dll", "none", "OutputDebugString", "str", $msg)
EndFunc   ;==>dbg

